-- Kicker
-- Author: ChaosInc
-- (c) 2009-2010 Joshua Mrozek , All rights reserved.

-- KICK MESSAGE
local KICKMSG = "Kicker: You've been kicked from the "


--[[ VARIABLE LAYOUT
Kicker = {
	[name] = {"reason"}
	}}
]]
Kicker = Kicker or CreateFrame("Frame")
Kicker:RegisterEvent("ADDON_LOADED")
Kicker:SetScript("OnEvent", function(self, event, ...) if Kicker[event] then return Kicker[event](self, event, ...) end end)

--[[ HOOK SLASH COMMANDS ]]
origGuildUnivite = SlashCmdList["GUILD_UNINVITE"]
origGuildLeave = SlashCmdList["GUILD_LEAVE"]

SlashCmdList["GUILD_UNINVITE"] = function(msg) Kicker_KickGuildie(msg) end
SlashCmdList["GUILD_LEAVE"] = function(msg) Kicker_LeaveGuild(msg) end

--[[ GUILD/OFFICER AUTO-UPDATES 
function Kicker:ADDON_LOADED(event)
	self:UnregisterEvent(event)
	Kicker.new = Kicker.new or {}
end

function Kicker:PLAYER_ENTERING_WORLD(event)
	self:UnregisterEvent(event)
	if not IsInGuild() then return end
	if CanGuildRemove() or IsGuildLeader(UnitName("player")) then
		SendAddonMessage("Kicker", "update", "GUILD")
	end
end
	
function Kicker:CHAT_MSG_ADDON(addon, msg, dest, who)
	if addon ~= "Kicker" or not IsInGuild() then return end
	msg,more = strsplit(":", msg) -- attempt to split message to determine info sent
	
	-- RECEIVED MORE INFO FROM REQUEST?	
	if more ~= nil or more ~= "" then
		self.newName.where = msg
		self.newName.reason = more
		return
	end
	
	-- NAME CHECK
	if self.msg then
		return -- do nothing, already have name
	elseif msg ~= "update" or msg ~= "new" then
		newName = msg
		self.msg = {} -- save name for future use
		SendAddonMessage("Kicker", "new", dest, who) -- request rest of info
	end
	
	-- UPDATE REQUESTED
	if msg = "update" then
		for name,_ in pairs(self) do  -- start sending names from your list to compare
			SendAddonMessage("Kicker", name, "GUILD",who)
		end
	end

	-- SENDER NEEDS MORE INFO
	if msg = "new" then
		msg = self.msg.where.. ":".. self.msg.reason -- combine where/reason data
		SendAddonMessage("Kicker", msg, dest, who)
	end
end]]
	
function Kicker_GetCmd(msg)
 	if msg then
 		local a,b,c=strfind(msg, "(%S+)");
 		if a then
 			return c, strsub(msg, b+2);
 		else	
 			return "";
 		end
 	end
 end

function Kicker_KickGuildie(msg)
	local name, reason = Kicker_GetCmd(msg)
	if reason == "" then reason = "Mr. Pinchy does not know!" end
	table.insert(Kicker.new, name)
	Kicker.new[name] = reason
	GuildUninvite(name)
	SendChatMessage(KICKMSG.. "guild. (".. reason..")", "WHISPER", nil, name)
	SendChatMessage(name.. " has been /gkicked! (".. reason.. ")", "GUILD")
end

function Kicker_LeaveGuild(msg)
	if msg == "" then msg = "Because I suck compared to the rest of you." end
	SendChatMessage("Kicker: ".. UnitName("player").. " just /gquit! (".. reason.. ")", "GUILD")
	GuildLeave()
end
